function I = int_newtoncotes(type, a, b, func, max_evals)

switch type
   case 'trapez'
      % Trapez
      ns = 2;
      sigmas = [1, 1];
   case 'simpson'
      % Simpson
      ns = 6;
      sigmas = [1, 4, 1];
   case 'milne'
      % Milne
      ns = 90;
      sigmas = [7, 32, 12, 32, 7];
   case 'weddle'
      % Weddle
      ns = 840;
      sigmas = [41, 216, 27, 272, 27, 216, 41];
   otherwise
      error('Unbekannte Regel');
end

n = length(sigmas)-1;

K = floor( (max_evals-1)/n );
max_evals = K*n+1;

pnts = linspace(a, b, max_evals);

fval = zeros(size(pnts));

for i=1:length(pnts)
   fval(i) = feval(func, pnts(i));
end

h = (b-a)/K;

summe = 0;
for i=1:n
   summe = summe + sum(fval(i:n:end-1))*sigmas(i);
end
summe = summe + sum(fval(n+1:n:end))*sigmas(end);

I = h/ns*summe;
