function test_function(func, max_eval_array)

if( size(max_eval_array, 2) > size(max_eval_array, 1) )
   max_eval_array = max_eval_array';
end

methods = {'int_romberg(', ...
           'int_newtoncotes(''trapez'',', ...
           'int_newtoncotes(''simpson'',', ...
           'int_newtoncotes(''milne'',', ...
           'int_newtoncotes(''weddle'',' };

a = feval(func, inf, 'a');
b = feval(func, inf, 'b');
I = feval(func, inf, 'I');
func_name = feval(func, inf, 'Name');

global counter;

err_mat = zeros(length(max_eval_array), length(methods));

disp(['Teste Funktion ', func, ' bis zu ', ...
      num2str(max_eval_array(end)), ' Auswertungen ' ]);
line_count = 0;

for ind_evals = 1:length(max_eval_array)

   fprintf('%d|', max_eval_array(ind_evals));
   line_count = line_count+1;
   if( line_count>15 )
      fprintf('\n');
      line_count = 0;
   end

   for ind_meth = 1:length(methods)

      max_evals = max_eval_array(ind_evals);

      counter = 0;
      exec_str = ['I_comp = ', methods{ind_meth}, ' a, b, func, max_evals);'];
      eval( exec_str );

      if( counter > max_evals )
         benutzte_funktionsauswertungen = counter
         vorgegebene_funktionsauswertungen = max_evals
         error(['Die Funktion ', methods{ind_meth}, ...
                ' benutzt mehr Funktionsauswertungen als vorgegeben!']);
      end

      err_mat(ind_evals, ind_meth) = abs(I_comp-I)/abs(I);
   end
end

fprintf('\n\n');

%
% Fehler Plot
%
subplot(1, 2, 1);
loglog(max_eval_array, err_mat(:, 1), 'b-');
hold on;
loglog(max_eval_array, err_mat(:, 2:end), '--', 'LineWidth', 2);
plot(max_eval_array(1), eps, 'w+');
hold off;

for i=1:length(methods)
   methods{i} = regexprep(methods{i}, 'int\_', '');
   methods{i} = regexprep(methods{i}, 'newtoncotes', '');
   methods{i} = regexprep(methods{i}, '\(', ' ');
   methods{i} = regexprep(methods{i}, ',', '');
end

legend(methods, 'Location', 'SouthWest');

title(['Funktionsname :   "', func_name,'";           ']);

xlabel('Anzahl der Funktionsauswertungen');
ylabel('Relativer Fehler');

%
% Funktions Plot
%
subplot(1, 2, 2);
interval = linspace(a, b, 1000);
funvals = zeros(size(interval));
for i=1:length(interval)
   funvals(i) = feval(func, interval(i));
end

plot(interval, funvals, 'b-');
hold on;
plot([interval(1), interval(end)], [0, 0], 'k-');
hold off;

title(['Integrationsinterval : [', num2str(a), ',', num2str(b), ']']);
